import time
import paho.mqtt.client as mqtt			# Import the MQTT library
import pygame
import math
from math import pi

# Pygame stuff
pygame.init()
size = (1000, 600)
screen = pygame.display.set_mode(size)
pygame.display.set_caption("UDAR")
pygame.font.init() 
myfont = pygame.font.SysFont('Arial', 50)
textsurface = myfont.render('!DANGER CLOSE!', False, (255, 0, 0))
clock = pygame.time.Clock()


# Our "on message" event
def messageFunction (client, userdata, message):
    topic = str(message.topic)
    message = str(message.payload.decode("utf-8"))
    split = message.split('#')
    angle = int(int(split[1]) / 5)
    distance = int(split[2])
    print(distance)
    print(angle)
    try:
        plotData[0][angle] = distance
        currentDir[0] = angle
    except:
        pass


applicationClose = False

# Variables
bytePtr = 0
strData = ""
strSplit = ""
GREEN =   (0, 255, 0)
BLUE =   (0, 0, 255)
RED = (255, 0, 0)
BLACK = (0, 0, 0)
textFlashFlag = False
dangerDetected = False
flashCounter = 0
fireSent = False

# Co-ords for the two radar graphics
radar_1_x = 250
radar_1_y = 500
radar_2_x = 750
radar_2_y = 500

dangerRange = 50

angle = 0
oppositeDir = False
plotData = []
currentDir = [0,0]

ourClient = mqtt.Client("makerio_mqtt")		# Create a MQTT client object
ourClient.connect("test.mosquitto.org", 1883)	# Connect to the test MQTT broker
ourClient.subscribe("radarData")		# Subscribe to the topic AC_unit
ourClient.on_message = messageFunction		# Attach the messageFunction to subscription
ourClient.loop_start()				# Start the MQTT client



# Create the plot data arrays
for j in range(2):
    column = []
    for i in range(0, 36):
        column.append(200)
    plotData.append(column)


# Infinte loop program
while(applicationClose == False):

    # Check to see if the quit button has been pressed
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            applicationClose = True
            pygamne.display.quit()
            pygame.quit()
        if event.type == pygame.KEYDOWN:
            ourClient.publish("trigger", "FIRE");


    # Determine if there is danger close
    dangerDetected = False
    
    for j in range(0, 2):
        for i in range(0, 36):
            if plotData[j][i] < dangerRange:
                dangerDetected = True

    if dangerDetected == True:
        if fireSent == False:
            pass
            ourClient.publish("trigger", "FIRE");
            fireSent = True
    else:
        fireSent = False
                
    # Draw the screen and the graphics
    screen.fill(BLACK)

    if dangerDetected == True:
        flashCounter += 1
        if(flashCounter > 60):
            flashCounter = 0
            textFlashFlag = not textFlashFlag
        if textFlashFlag == True:
            screen.blit(textsurface, (300,50))

    for j in range(0, 2):
        
        # Plot data
        for i in range(0, 36):
           
            # Get angle
            angle = i * 5
            
            if(angle < 90):
                oppositeDir = True
            else:
                angle = (180 - angle)
                oppositeDir = False

            angle = math.radians(angle)
            
            xLen = math.cos(angle) * plotData[j][i]    
            yLen = math.sin(angle) * plotData[j][i]

            if(oppositeDir == True):
                xLen = -xLen

            if(currentDir[j] == i):
                if(j == 0):
                    pygame.draw.line(screen, GREEN, (radar_1_x, radar_1_y), (radar_1_x + xLen, radar_1_y - yLen), 4)        
                else:
                    pygame.draw.line(screen, GREEN, (radar_2_x, radar_2_y), (radar_2_x + xLen, radar_2_y - yLen), 4)    
            else:
                if(j == 0):
                    pygame.draw.line(screen, BLUE, (radar_1_x, radar_1_y), (radar_1_x + xLen, radar_1_y - yLen), 4)       
                else:
                    pygame.draw.line(screen, BLUE, (radar_2_x, radar_2_y), (radar_2_x + xLen, radar_2_y - yLen), 4)

    pygame.draw.arc(screen, GREEN, [radar_1_x - 200, radar_1_y - 200, 400, 400], 0, pi, 2)
    pygame.draw.arc(screen, RED, [radar_1_x - (dangerRange / 2), radar_1_y - (dangerRange / 2), dangerRange, dangerRange], 0, pi, 2)
    pygame.draw.arc(screen, GREEN, [radar_2_x - 200, radar_2_y - 200, 400, 400], 0, pi, 2)
    pygame.draw.arc(screen, RED, [radar_2_x - 30, radar_2_y - 30, 60, 60], 0, pi, 2)   
            
    pygame.display.flip()
    clock.tick(60)
